diff --git a/src/backend/commands/copy.c b/src/backend/commands/copy.c
index 70f50e7a9a0..96fd88cf7de 100644
--- a/src/backend/commands/copy.c
+++ b/src/backend/commands/copy.c
@@ -5620,11 +5620,10 @@ NextCopyFromExecute(CopyState cstate, ExprContext *econtext,
 
 		resultRelInfo = targetid_get_partition(frame.relid, estate, true);
 		estate->es_result_relation_info = resultRelInfo;
+		slot = reconstructMatchingTupleSlot(baseSlot, resultRelInfo);
 
 		MemoryContextSwitchTo(oldcontext);
 
-		slot = reconstructMatchingTupleSlot(baseSlot, resultRelInfo);
-
 		/* since resultRelInfo has changed, refresh these values */
 		tupDesc = RelationGetDescr(resultRelInfo->ri_RelationDesc);
 		attr = tupDesc->attrs;
diff --git a/src/test/regress/expected/gpcopy_dispatch.out b/src/test/regress/expected/gpcopy_dispatch.out
index 1d2a7607a9e..1eaee52ff3e 100644
--- a/src/test/regress/expected/gpcopy_dispatch.out
+++ b/src/test/regress/expected/gpcopy_dispatch.out
@@ -94,3 +94,33 @@ COPY partdisttest FROM stdin;
 INFO:  first field processed in the QE: 3
 CONTEXT:  COPY partdisttest, line 0
 DROP TABLE partdisttest;
+CREATE TABLE partdisttest (dropped bool, a smallint, b smallint)
+  DISTRIBUTED BY (a)
+  PARTITION BY RANGE(a)
+  (PARTITION segundo START(5));
+NOTICE:  CREATE TABLE will create partition "partdisttest_1_prt_segundo" for table "partdisttest"
+ALTER TABLE partdisttest DROP dropped;
+ALTER TABLE partdisttest ADD PARTITION primero START(0) END(5);
+NOTICE:  CREATE TABLE will create partition "partdisttest_1_prt_primero" for table "partdisttest"
+-- We used to have bug, when a partition has a different distribution
+-- column number than the base table, we'd lazily construct a tuple
+-- table slot for that partition, but in a (mistakenly) short-lived
+-- per query memory context. COPY FROM uses batch size of
+-- MAX_BUFFERED_TUPLES tuples, and after that it resets the per query
+-- context. As a result while processing second batch, segment used to
+-- crash. This test exposed the bug and now validates the fix.
+COPY (
+    SELECT 2,1
+    FROM (
+        SELECT generate_series(1, MAX_BUFFERED_TUPLES + 1)
+        FROM (VALUES (10000)) t(MAX_BUFFERED_TUPLES)
+        ) t
+    ) TO '/tmp/thousand-and-one-lines.txt';
+COPY partdisttest FROM '/tmp/thousand-and-one-lines.txt';
+INFO:  first field processed in the QE: 1
+SELECT tableoid::regclass, count(*) FROM partdisttest GROUP BY 1;
+          tableoid          | count 
+----------------------------+-------
+ partdisttest_1_prt_primero | 10001
+(1 row)
+
diff --git a/src/test/regress/sql/gpcopy_dispatch.sql b/src/test/regress/sql/gpcopy_dispatch.sql
index a4323c0d36e..11f3423df0c 100644
--- a/src/test/regress/sql/gpcopy_dispatch.sql
+++ b/src/test/regress/sql/gpcopy_dispatch.sql
@@ -110,3 +110,28 @@ COPY partdisttest FROM stdin;
 \.
 
 DROP TABLE partdisttest;
+
+CREATE TABLE partdisttest (dropped bool, a smallint, b smallint)
+  DISTRIBUTED BY (a)
+  PARTITION BY RANGE(a)
+  (PARTITION segundo START(5));
+ALTER TABLE partdisttest DROP dropped;
+ALTER TABLE partdisttest ADD PARTITION primero START(0) END(5);
+
+-- We used to have bug, when a partition has a different distribution
+-- column number than the base table, we'd lazily construct a tuple
+-- table slot for that partition, but in a (mistakenly) short-lived
+-- per query memory context. COPY FROM uses batch size of
+-- MAX_BUFFERED_TUPLES tuples, and after that it resets the per query
+-- context. As a result while processing second batch, segment used to
+-- crash. This test exposed the bug and now validates the fix.
+COPY (
+    SELECT 2,1
+    FROM (
+        SELECT generate_series(1, MAX_BUFFERED_TUPLES + 1)
+        FROM (VALUES (10000)) t(MAX_BUFFERED_TUPLES)
+        ) t
+    ) TO '/tmp/thousand-and-one-lines.txt';
+COPY partdisttest FROM '/tmp/thousand-and-one-lines.txt';
+
+SELECT tableoid::regclass, count(*) FROM partdisttest GROUP BY 1;
